VehicleInspector = {};

VehicleInspector.metadata = {
	interface = " FS19 1.x",
	title = " VehicleInspector",
	notes = " Zeigt/Ändert Vehicle Informationen/Bestände und vieles mehr in einem PDA Hud an",
	author = " (by HappyLooser)",
	version = " v1.4 Beta",
	datum = " 05.11.2016",
	update = " 04.12.2018",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

function VehicleInspector:loadMap(name)
	g_currentMission.vehicleInspector = VehicleInspector;	
	print("---loading".. tostring(VehicleInspector.metadata.title).. tostring(VehicleInspector.metadata.version).. tostring(VehicleInspector.metadata.author).. "---")
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	VehicleInspector.settingsDir = getUserProfileAppPath().. "modsSettings/VehicleInspector/";																					
	VehicleInspector.simple = {isOn=true,rebootXml=false,showHelpOn=false,showHelpOff=true,allTxtBold=false,vehicleSchemaPosY=0,defaultPosX=0.01,helpHudPosY=0.98,defaultPosY=0.98,defaultSize=0.010,diffPosX=0.001,diffPosY=0.005,
	seeField=false,seeSpeed=true,seeFillName=true,realFillName=false,isFillFull=false,seeFillLevel=true,seeTrain=false,seeProzent=true,ownFarmVehicle=false,seePlayerName=true,seeVehicleName=false,seeVehicleSmallName=true;isHelper=true,isPlayer=true,isBlocking=true,isFuel=false,isWater=true,
	seeVehicleTypeName=false,isDamage=false,seeLastAllAttached=true, attachedLimit=4, seperator="|"};
	if g_currentMission.hud ~= nil and g_currentMission.hud.vehicleSchema ~= nil and g_currentMission.hud.vehicleSchema.overlay ~= nil then VehicleInspector.simple.vehicleSchemaPosY = Utils.getNoNil(g_currentMission.hud.vehicleSchema.overlay.y, VehicleInspector.simple.defaultPosY);end;
	VehicleInspector.simple.txt = {		
		speed = " km";
		field = "F ";
		fillNameToFillLevel = " ";  --is Seperator
		helperS = "H";
		otherT = "O";				
		playerS = "P";				
		otherSaFull = "! Empty !";
		otherSa = "^";				--is Seperator, see better Seeds/sowing etc.
		otherSaOrFill = "?";		--is Seperator, Seeds/sowing or Fill is Unknown etc.
		otherW = "! Water !";
		otherD = "! Damage !";
		otherB = "! Blocking !";
		otherFuel = "! Fuel Empty !";
		otherFull = "! Full !";
	};
	VehicleInspector.simple.searchInvert = {"sowing", "sowingmachine", "sprayer", "fertilizer", "manure"};
	VehicleInspector.simple.color = {
		default={1, 1, 1, 1}
	};
	
	VehicleInspector:setGetCfg(true);	
end;

function VehicleInspector:deleteMap()
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	VehicleInspector:setGetCfg(false);	
end;

function VehicleInspector:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VehicleInspector:keyEvent(unicode, sym, modifier, isDown)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if VehicleInspector.simple.rebootXml and Input.isKeyPressed(Input.KEY_esc) then
		if g_currentMission.inGameMenu.isOpen then VehicleInspector:setGetCfg(true);end;		
	end;	
end;

function VehicleInspector:update(dt)	
end;

function VehicleInspector:draw(dt)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
	if VehicleInspector.simple.isOn and not VehicleInspector:getFullSize() and not VehicleInspector:getIngameMap() then 
		local seeDrawSimple = false;
		if VehicleInspector.simple.showHelpOn and VehicleInspector.simple.showHelpOff then 
			VehicleInspector:setPosX_Y(true, true, g_gameSettings:getValue("showHelpMenu"));
			seeDrawSimple = true;
		elseif VehicleInspector.simple.showHelpOn and g_gameSettings:getValue("showHelpMenu") then
			VehicleInspector:setPosX_Y(true, false, true);
			seeDrawSimple = true;
		elseif 	VehicleInspector.simple.showHelpOff and not g_gameSettings:getValue("showHelpMenu") then
			VehicleInspector:setPosX_Y(false, true, false);
			seeDrawSimple = true;
		end;
		
		if seeDrawSimple then VehicleInspector:drawSimple();end;
	end;	
end;
addModEventListener(VehicleInspector);

function VehicleInspector:setGetCfg(loadCfg)
	createFolder(getUserProfileAppPath().. "modsSettings/");
	createFolder(VehicleInspector.settingsDir);
	local file = VehicleInspector.settingsDir.. "vehicleInspectorSettings.xml";
	local Xml = nil;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("VehicleInspector_XML", file, "vehicleInspectorSettings");
		local groupNameTag = ("vehicleInspectorSettings.simple.global(%d)"):format(0);		
		setXMLFloat(Xml, groupNameTag.. "#posX", VehicleInspector.simple.defaultPosX);
		setXMLFloat(Xml, groupNameTag.. "#posY", VehicleInspector.simple.defaultPosY);		
		setXMLFloat(Xml, groupNameTag.. "#size", VehicleInspector.simple.defaultSize);	
		setXMLBool(Xml, groupNameTag.. "#allTxtBold", VehicleInspector.simple.allTxtBold);
		setXMLBool(Xml, groupNameTag.. "#showHelpOn", VehicleInspector.simple.showHelpOn);
		setXMLBool(Xml, groupNameTag.. "#showHelpOff", VehicleInspector.simple.showHelpOff);
		setXMLBool(Xml, groupNameTag.. "#rebootXmlESC", VehicleInspector.simple.rebootXml);
		setXMLBool(Xml, groupNameTag.. "#isOn", VehicleInspector.simple.isOn);
		
		groupNameTag = ("vehicleInspectorSettings.simple.show(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#seeField", VehicleInspector.simple.seeField);
		setXMLBool(Xml, groupNameTag.. "#seeSpeed", VehicleInspector.simple.seeSpeed);		
		setXMLBool(Xml, groupNameTag.. "#seeFillName", VehicleInspector.simple.seeFillName);
		setXMLBool(Xml, groupNameTag.. "#realFillName", VehicleInspector.simple.realFillName);		
		setXMLBool(Xml, groupNameTag.. "#seeFillLevel", VehicleInspector.simple.seeFillLevel);
		setXMLBool(Xml, groupNameTag.. "#seeProzent", VehicleInspector.simple.seeProzent);
		setXMLBool(Xml, groupNameTag.. "#seePlayerName", VehicleInspector.simple.seePlayerName);
		setXMLBool(Xml, groupNameTag.. "#seeVehicleName", VehicleInspector.simple.seeVehicleName);
		setXMLBool(Xml, groupNameTag.. "#seeVehicleSmallName", VehicleInspector.simple.seeVehicleSmallName);
		setXMLBool(Xml, groupNameTag.. "#seeVehicleTypeName", VehicleInspector.simple.seeVehicleTypeName);
		setXMLBool(Xml, groupNameTag.. "#seeLastAllAttached", VehicleInspector.simple.seeLastAllAttached);		
		
		groupNameTag = ("vehicleInspectorSettings.simple.seeVehicle(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#isFillFull", VehicleInspector.simple.isFillFull);
		setXMLBool(Xml, groupNameTag.. "#isTrain", VehicleInspector.simple.seeTrain);
		setXMLBool(Xml, groupNameTag.. "#isPlayer", VehicleInspector.simple.isPlayer);
		setXMLBool(Xml, groupNameTag.. "#isHelper", VehicleInspector.simple.isHelper);
		
		groupNameTag = ("vehicleInspectorSettings.simple.extraShow(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#isFuel", VehicleInspector.simple.isFuel);
		setXMLBool(Xml, groupNameTag.. "#isBlocking", VehicleInspector.simple.isBlocking);
		setXMLBool(Xml, groupNameTag.. "#isDamage", VehicleInspector.simple.isDamage);
		setXMLBool(Xml, groupNameTag.. "#isWater", VehicleInspector.simple.isWater);
		
		groupNameTag = ("vehicleInspectorSettings.simple.other(%d)"):format(0);
		--setXMLInt(Xml, groupNameTag.. "#attachedLimit", VehicleInspector.simple.attachedLimit);		
		--setXMLFloat(Xml, groupNameTag.. "#diffPosX", VehicleInspector.simple.diffPosX);
		--setXMLFloat(Xml, groupNameTag.. "#diffPosY", VehicleInspector.simple.diffPosY);
		local searchInvertTemp = ""
		for key,value in pairs(VehicleInspector.simple.searchInvert) do
			if string.len(searchInvertTemp) > 0 then searchInvertTemp = searchInvertTemp.. ",".. tostring(VehicleInspector.simple.searchInvert[key])
			else searchInvertTemp = searchInvertTemp.. tostring(VehicleInspector.simple.searchInvert[key]);end;
		end;
		setXMLString(Xml, groupNameTag.. "#searchInvert", tostring(searchInvertTemp));
		
		groupNameTag = ("vehicleInspectorSettings.simple.seperator(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#default", VehicleInspector.simple.seperator);
		setXMLString(Xml, groupNameTag.. "#fillNameToFillLevel", VehicleInspector.simple.txt.fillNameToFillLevel);		
		
		groupNameTag = ("vehicleInspectorSettings.simple.txt(%d)"):format(0);		
		setXMLString(Xml, groupNameTag.. "#speedTxt", VehicleInspector.simple.txt.speed);
		setXMLString(Xml, groupNameTag.. "#fieldTxt", VehicleInspector.simple.txt.field);
		setXMLString(Xml, groupNameTag.. "#otherT", VehicleInspector.simple.txt.otherT);
		setXMLString(Xml, groupNameTag.. "#helperS", VehicleInspector.simple.txt.helperS);
		setXMLString(Xml, groupNameTag.. "#playerS", VehicleInspector.simple.txt.playerS);
		setXMLString(Xml, groupNameTag.. "#otherSa", VehicleInspector.simple.txt.otherSa);
		setXMLString(Xml, groupNameTag.. "#otherSaFull", VehicleInspector.simple.txt.otherSaFull);
		setXMLString(Xml, groupNameTag.. "#otherSaOrFill", VehicleInspector.simple.txt.otherSaOrFill);
		setXMLString(Xml, groupNameTag.. "#otherW", VehicleInspector.simple.txt.otherW);
		setXMLString(Xml, groupNameTag.. "#otherD", VehicleInspector.simple.txt.otherD);
		setXMLString(Xml, groupNameTag.. "#otherB", VehicleInspector.simple.txt.otherB);
		setXMLString(Xml, groupNameTag.. "#otherFuel", VehicleInspector.simple.txt.otherFuel);
		setXMLString(Xml, groupNameTag.. "#otherFull", VehicleInspector.simple.txt.otherFull);
		
		groupNameTag = ("vehicleInspectorSettings.simple.color(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#defaultColorA", VehicleInspector.simple.color.default[4]);
		setXMLFloat(Xml, groupNameTag.. "#defaultColorB", VehicleInspector.simple.color.default[3]);
		setXMLFloat(Xml, groupNameTag.. "#defaultColorG", VehicleInspector.simple.color.default[2]);
		setXMLFloat(Xml, groupNameTag.. "#defaultColorR", VehicleInspector.simple.color.default[1]);
		saveXMLFile(Xml);
	else
		Xml = loadXMLFile("VehicleInspector_XML", file, "vehicleInspectorSettings");
		local groupNameTag = ("vehicleInspectorSettings.simple.global(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#isOn") ~= nil then VehicleInspector.simple.isOn = getXMLBool(Xml, groupNameTag.. "#isOn");end;
		if getXMLBool(Xml, groupNameTag.. "#rebootXmlESC") ~= nil then VehicleInspector.simple.rebootXml = getXMLBool(Xml, groupNameTag.. "#rebootXmlESC");end;
		if getXMLBool(Xml, groupNameTag.. "#showHelpOn") ~= nil then VehicleInspector.simple.showHelpOn = getXMLBool(Xml, groupNameTag.. "#showHelpOn");end;
		if getXMLBool(Xml, groupNameTag.. "#showHelpOff") ~= nil then VehicleInspector.simple.showHelpOff = getXMLBool(Xml, groupNameTag.. "#showHelpOff");end;
		if getXMLBool(Xml, groupNameTag.. "#allTxtBold") ~= nil then VehicleInspector.simple.allTxtBold = getXMLBool(Xml, groupNameTag.. "#allTxtBold");end;
		if getXMLFloat(Xml, groupNameTag.. "#size") then VehicleInspector.simple.defaultSize = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLFloat(Xml, groupNameTag.. "#posX") then VehicleInspector.simple.defaultPosX = getXMLFloat(Xml, groupNameTag.. "#posX");end;
		if getXMLFloat(Xml, groupNameTag.. "#posY") then VehicleInspector.simple.defaultPosY = getXMLFloat(Xml, groupNameTag.. "#posY");end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.show(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#seeField") ~= nil then VehicleInspector.simple.seeField = getXMLBool(Xml, groupNameTag.. "#seeField");end;
		if getXMLBool(Xml, groupNameTag.. "#seeSpeed") ~= nil then VehicleInspector.simple.seeSpeed = getXMLBool(Xml, groupNameTag.. "#seeSpeed");end;
		if getXMLBool(Xml, groupNameTag.. "#seeFillName") ~= nil then VehicleInspector.simple.seeFillName = getXMLBool(Xml, groupNameTag.. "#seeFillName");end;
		if getXMLBool(Xml, groupNameTag.. "#seeFillLevel") ~= nil then VehicleInspector.simple.seeFillLevel = getXMLBool(Xml, groupNameTag.. "#seeFillLevel");end;
		if getXMLBool(Xml, groupNameTag.. "#realFillName") ~= nil then VehicleInspector.simple.realFillName = getXMLBool(Xml, groupNameTag.. "#realFillName");end;
		if getXMLBool(Xml, groupNameTag.. "#seeProzent") ~= nil then VehicleInspector.simple.seeProzent = getXMLBool(Xml, groupNameTag.. "#seeProzent");end;
		if getXMLBool(Xml, groupNameTag.. "#seePlayerName") ~= nil then VehicleInspector.simple.seePlayerName = getXMLBool(Xml, groupNameTag.. "#seePlayerName");end;
		if getXMLBool(Xml, groupNameTag.. "#seeVehicleName") ~= nil then VehicleInspector.simple.seeVehicleName = getXMLBool(Xml, groupNameTag.. "#seeVehicleName");end;
		if getXMLBool(Xml, groupNameTag.. "#seeVehicleSmallName") ~= nil then VehicleInspector.simple.seeVehicleSmallName = getXMLBool(Xml, groupNameTag.. "#seeVehicleSmallName");end;
		if getXMLBool(Xml, groupNameTag.. "#seeVehicleTypeName") ~= nil then VehicleInspector.simple.seeVehicleTypeName = getXMLBool(Xml, groupNameTag.. "#seeVehicleTypeName");end;
		if getXMLBool(Xml, groupNameTag.. "#seeLastAllAttached") ~= nil then VehicleInspector.simple.seeLastAllAttached = getXMLBool(Xml, groupNameTag.. "#seeLastAllAttached");end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.seeVehicle(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#isFillFull") ~= nil then VehicleInspector.simple.isFillFull = getXMLBool(Xml, groupNameTag.. "#isFillFull");end;
		if getXMLBool(Xml, groupNameTag.. "#isTrain") ~= nil then VehicleInspector.simple.isTrain = getXMLBool(Xml, groupNameTag.. "#isTrain");end;
		if getXMLBool(Xml, groupNameTag.. "#isPlayer") ~= nil then VehicleInspector.simple.isPlayer = getXMLBool(Xml, groupNameTag.. "#isPlayer");end;
		if getXMLBool(Xml, groupNameTag.. "#isHelper") ~= nil then VehicleInspector.simple.isHelper = getXMLBool(Xml, groupNameTag.. "#isHelper");end;		
		
		groupNameTag = ("vehicleInspectorSettings.simple.extraShow(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#isBlocking") ~= nil then VehicleInspector.simple.isBlocking = getXMLBool(Xml, groupNameTag.. "#isBlocking");end;
		if getXMLBool(Xml, groupNameTag.. "#isDamage") ~= nil then VehicleInspector.simple.isDamage = getXMLBool(Xml, groupNameTag.. "#isDamage");end;
		if getXMLBool(Xml, groupNameTag.. "#isWater") ~= nil then VehicleInspector.simple.isWater = getXMLBool(Xml, groupNameTag.. "#isWater");end;
		if getXMLBool(Xml, groupNameTag.. "#isFuel") ~= nil then VehicleInspector.simple.isFuel = getXMLBool(Xml, groupNameTag.. "#isFuel");end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.other(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#diffPosX") then VehicleInspector.simple.diffPosX = getXMLFloat(Xml, groupNameTag.. "#diffPosX");end;
		if getXMLFloat(Xml, groupNameTag.. "#diffPosY") then VehicleInspector.simple.diffPosY = getXMLFloat(Xml, groupNameTag.. "#diffPosY");end;
		if getXMLInt(Xml, groupNameTag.. "#attachedLimit") then VehicleInspector.simple.attachedLimit = getXMLInt(Xml, groupNameTag.. "#attachedLimit");end;
		local searchInvertTemp = "";
		if getXMLString(Xml, groupNameTag.. "#searchInvert") ~= nil then searchInvertTemp = getXMLString(Xml, groupNameTag.. "#searchInvert");end;
		local stringSplit = VehicleInspector:stringSplit(searchInvertTemp, ",");
		if stringSplit ~= nil and #stringSplit > 0 then
			searchInvertTemp = ",";
			--for a=1, #stringSplit do
			--	if stringSplit[a] ~= nil then
			--		local invertString = tostring(stringSplit[a]);
			--		searchInvertTemp = searchInvertTemp.. invertString.. ",";
			--		if VehicleInspector.simple.searchInvert[invertString] == nil then table.insert(VehicleInspector.simple.searchInvert, invertString);end;
			--	end;
			--end;
			VehicleInspector.simple.searchInvert = {};
			for key,value in pairs(stringSplit) do				
				if VehicleInspector.simple.searchInvert[key] == nil then table.insert(VehicleInspector.simple.searchInvert, tostring(string.lower(stringSplit[key])));end;
				searchInvertTemp = searchInvertTemp.. tostring(string.lower(stringSplit[key])).. ",";
			end;
			--for key,value in pairs(VehicleInspector.simple.searchInvert) do
			--	if not string.find(searchInvertTemp, ",".. VehicleInspector.simple.searchInvert[key].. ",") then
			--		VehicleInspector.simple.searchInvert[key] = nil;
			--	end;
			--end;
		end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.seperator(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#default") ~= nil then VehicleInspector.simple.seperator = getXMLString(Xml, groupNameTag.. "#default");end;
		if getXMLString(Xml, groupNameTag.. "#fillNameToFillLevel") ~= nil then VehicleInspector.simple.txt.fillNameToFillLevel = getXMLString(Xml, groupNameTag.. "#fillNameToFillLevel");end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.txt(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#speedTxt") ~= nil then VehicleInspector.simple.txt.speed = getXMLString(Xml, groupNameTag.. "#speedTxt");end;
		if getXMLString(Xml, groupNameTag.. "#fieldTxt") ~= nil then VehicleInspector.simple.txt.field = getXMLString(Xml, groupNameTag.. "#fieldTxt");end;
		if getXMLString(Xml, groupNameTag.. "#otherT") ~= nil then VehicleInspector.simple.txt.otherT = getXMLString(Xml, groupNameTag.. "#otherT");end;
		if getXMLString(Xml, groupNameTag.. "#otherSa") ~= nil then VehicleInspector.simple.txt.otherSa = getXMLString(Xml, groupNameTag.. "#otherSa");end;
		if getXMLString(Xml, groupNameTag.. "#otherSaFull") ~= nil then VehicleInspector.simple.txt.otherSaFull = getXMLString(Xml, groupNameTag.. "#otherSaFull");end;
		if getXMLString(Xml, groupNameTag.. "#otherSaOrFill") ~= nil then VehicleInspector.simple.txt.otherSaOrFill = getXMLString(Xml, groupNameTag.. "#otherSaOrFill");end;
		if getXMLString(Xml, groupNameTag.. "#otherW") ~= nil then VehicleInspector.simple.txt.otherW = getXMLString(Xml, groupNameTag.. "#otherW");end;
		if getXMLString(Xml, groupNameTag.. "#otherD") ~= nil then VehicleInspector.simple.txt.otherD = getXMLString(Xml, groupNameTag.. "#otherD");end;
		if getXMLString(Xml, groupNameTag.. "#otherB") ~= nil then VehicleInspector.simple.txt.otherB = getXMLString(Xml, groupNameTag.. "#otherB");end;
		if getXMLString(Xml, groupNameTag.. "#otherFuel") ~= nil then VehicleInspector.simple.txt.otherFuel = getXMLString(Xml, groupNameTag.. "#otherFuel");end;
		if getXMLString(Xml, groupNameTag.. "#otherFull") ~= nil then VehicleInspector.simple.txt.otherFull = getXMLString(Xml, groupNameTag.. "#otherFull");end;
		if getXMLString(Xml, groupNameTag.. "#helperS") ~= nil then VehicleInspector.simple.txt.helperS = getXMLString(Xml, groupNameTag.. "#helperS");end;
		if getXMLString(Xml, groupNameTag.. "#playerS") ~= nil then VehicleInspector.simple.txt.playerS = getXMLString(Xml, groupNameTag.. "#playerS");end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.color(%d)"):format(0);
	end;
end;

function VehicleInspector:setPosX_Y(showHelpOn, showHelpOff, isShowHelpMenu)
	if showHelpOn and isShowHelpMenu then
		if g_currentMission.hud.inputHelp ~= nil and g_currentMission.hud.inputHelp.overlay ~= nil then
			VehicleInspector.simple.defaultPosY = g_currentMission.hud.inputHelp.overlay.y;
		end;
	elseif showHelpOff and not isShowHelpMenu then
		if (g_currentMission.vehicleFruitHud ~= nil and g_currentMission.vehicleFruitHud.schemaPos == 1) or g_currentMission.vehicleFruitHud == nil then
			VehicleInspector.simple.defaultPosY = VehicleInspector.simple.vehicleSchemaPosY;
		end;
	end;
end;

function VehicleInspector:drawSimple()	
	local size = VehicleInspector.simple.defaultSize;
	local posX = VehicleInspector.simple.defaultPosX;
	local posY = VehicleInspector.simple.defaultPosY;
	local diffPosY = VehicleInspector.simple.diffPosY;
	local diffPosX = VehicleInspector.simple.diffPosX;	
	--if g_gameSettings.ingameMapState == 0 then posX = 0.0;end; --LS19 render Error(see slide Effect HelpMenu)
	--g_vehicleTypeManager
	if g_currentMission.vehicles ~= nil then
		local txtHeight = 0;		
		local outputStringLimit = 4;		
		--for key, value in pairs(g_currentMission.vehicles) do
		for a=1, #g_currentMission.vehicles do
			local vehicle = g_currentMission.vehicles[a];			
			if vehicle ~= nil and vehicle.getIsControlled ~= nil then --and vehicle.getCurrentHelper ~= nil then
				local txtWidth = 0;
				local seperator = VehicleInspector.simple.seperator;
				local fillNameToFillLevel = VehicleInspector.simple.txt.fillNameToFillLevel;
				local helperS = VehicleInspector.simple.txt.helperS;
				local otherT = VehicleInspector.simple.txt.otherT;			
				local playerS = VehicleInspector.simple.txt.playerS;				
				local otherSaFull = VehicleInspector.simple.txt.otherSaFull;
				local otherSaOrFill = VehicleInspector.simple.txt.otherSaOrFill;
				local otherSa = VehicleInspector.simple.txt.otherSa;
				local otherW = VehicleInspector.simple.txt.otherW;
				local otherD = VehicleInspector.simple.txt.otherD;
				local otherB = VehicleInspector.simple.txt.otherB;
				local otherFuel = VehicleInspector.simple.txt.otherFuel;
				local otherFull = VehicleInspector.simple.txt.otherFull;
				local outputString = {};
				outputString[#outputString+1] = {};
				outputString[#outputString].txt = "";				
				if VehicleInspector.simple.seePlayerName and vehicle.getIsControlled(vehicle) then playerS = vehicle.getControllerName(vehicle);end;
				if vehicle.getIsControlled(vehicle) and g_gameSettings.nickname == vehicle.getControllerName(vehicle) then outputString[#outputString].txtBold = true;end;
				local seeLine = false;
				--if VehicleInspector.simple.isFillFull and vehicle.getFillUnitFillLevelPercentage ~= nil and vehicle.getFillUnitFillLevelPercentage(vehicle) >= 100 then seeLine = true;outputString[#outputString].txt = otherS;end;
				if VehicleInspector.simple.seeTrain and ((vehicle.viVehicleName ~= nil and vehicle.viVehicleName == "Train") or vehicle.trainSystem ~= nil) then seeLine = true;outputString[#outputString].txt = outputString[#outputString].txt.. otherT;end;
				if VehicleInspector.simple.isHelper and vehicle.getCurrentHelper ~= nil and vehicle.getCurrentHelper(vehicle) then seeLine = true;outputString[#outputString].txt = outputString[#outputString].txt.. helperS;end;
				if VehicleInspector.simple.isPlayer and vehicle.getIsControlled(vehicle) then 
					seeLine = true;
					if string.len(outputString[#outputString].txt) > 0 then outputString[#outputString].txt = outputString[#outputString].txt.. "+";end;
					outputString[#outputString].txt = outputString[#outputString].txt.. playerS;outputString[#outputString].txtColor = { 0/255, 255/255, 255/255, 1 }; --ls15 Player Controlled
					if VehicleInspector.simple.allTxtBold and g_gameSettings.nickname ~= vehicle.getControllerName(vehicle) then outputString[#outputString].txtColor = { 0/255, 255/255, 255/255, 0.80 };end; --ls15Disabled a Player and NOT Controlled
				end;				
				--if vehicle.getIsControlled(vehicle) then seeLine = true;outputString[#outputString].txt = outputString[#outputString].txt.. playerS;outputString[#outputString].txtColor = {   0/255, 255/255, 255/255, 1.00 };end;
				--if VehicleInspector.simple.ownFarmVehicle and vehicle.ownerFarmId ~= FarmManager.getFarmByUserId(FarmlandManager, g_currentMission.playerUserId) then seeLine = false;end;
				
				if seeLine then					
					if VehicleInspector.simple.seeVehicleName or VehicleInspector.simple.seeVehicleSmallName or VehicleInspector.simple.seeVehicleTypeName then
						outputString[#outputString+1] = {};
						VehicleInspector:setVehicleName(self, vehicle, false);					
						outputString[#outputString].txt = tostring(vehicle.viVehicleName);
						if VehicleInspector.simple.seeVehicleSmallName then outputString[#outputString].txt = tostring(vehicle.getName(vehicle));end;
						if VehicleInspector.simple.seeVehicleTypeName then outputString[#outputString].txt = tostring(vehicle.typeDesc);end;
					end;					
					if VehicleInspector.simple.seeField and vehicle.trainSystem == nil then						
						table.insert(outputString, 1, {});
						local field = 0;
						--if vehicle.getIsOnField(vehicle) then field = VehicleInspector:getIsOnField(vehicle);end;
						if vehicle.getIsOnField(vehicle) then 
							field = VehicleInspector:getIsOnField(vehicle);
							outputString[1].txtBold = true;
							outputString[1].txtColor = { 255/255, 0/255, 255/255, 1.00 }; --mangenta
						end;
						outputString[1].txt = tostring(VehicleInspector.simple.txt.field); --.. tostring(field);						
					end;
					if VehicleInspector.simple.seeSpeed then
						table.insert(outputString, 1, {});						
						outputString[1].txt = VehicleInspector:getSpeed(vehicle).. tostring(VehicleInspector.simple.txt.speed);
					end;					
					if vehicle.trainSystem == nil and VehicleInspector.simple.isWater and vehicle.showTailwaterDepthWarning then						
						--outputString[#outputString+1] = {};
						table.insert(outputString, 1, {});
						outputString[1].txt = otherW;
						outputString[1].txtColor = { 0/255, 0/255, 255/255, 1 }; --darkBlue onWater
						outputString[1].txtBold = true;
					end;
					if vehicle.trainSystem == nil and VehicleInspector.simple.isDamage and vehicle.isBroken then						
						--outputString[#outputString+1] = {};
						table.insert(outputString, 1, {});
						outputString[1].txt = otherD;
						outputString[1].txtColor = { 255/255, 165/255,  0/255, 1 }; --orange Damage
						outputString[1].txtBold = true;
					end;
					
					--vehicle.spec_aiVehicle
					--aiTrafficCollisionTranslation-----table: 0x017f78dd93d0
					--aiTrafficCollision = 112459
					--debugTexts-----table: 0x017f551596c0
					if VehicleInspector.simple.isBlocking and not vehicle.showTailwaterDepthWarning and vehicle.spec_aiVehicle ~= nil and vehicle.spec_aiVehicle.debugTexts ~= nil then							
						if vehicle.spec_aiVehicle.debugTexts[1] ~= nil and string.find(vehicle.spec_aiVehicle.debugTexts[1], "STOP") and string.find(vehicle.spec_aiVehicle.debugTexts[1], "collision") then		
							table.insert(outputString, 1, {});
							outputString[1].txt = otherB;
							outputString[1].txtColor = { 255/255, 0/255, 0/255, 1 }; --red Blocking
							outputString[1].txtBold = true;	
						end;						
					end;					
					local attach, attachedSprayerAnd = VehicleInspector:getAttachedAndSprayerAnd(vehicle, 1);
					local fillLevelTable = {};
					if vehicle.getFillLevelInformation ~= nil then
						vehicle:getFillLevelInformation(fillLevelTable);
						for _,fillLevelVehicle in pairs(fillLevelTable) do
							if fillLevelVehicle.fillLevel > 0 then
								outputString[#outputString+1] = {};
								local typeName = Utils.getNoNil(string.lower(vehicle.typeName), "Unknown");
								local invertProzent = VehicleInspector:isInvertFill(typeName) or (attachedSprayerAnd > 0 and attach == 1) or (attachedSprayerAnd == attach);--string.find(typeName, "sowing") or string.find(typeName, "sprayer") or string.find(typeName, "manure") or string.find(typeName, "fertilizer") or attachedSprayerAnd > 0;
								if VehicleInspector.simple.seeFillLevel then
									outputString[#outputString].txt = string.format("%1.0f", Utils.getNoNil(fillLevelVehicle.fillLevel, 0));									
									if fillLevelVehicle.capacity > 0 then
										if (attachedSprayerAnd <= 1 and attach == 1) or (attachedSprayerAnd == attach) then --Unknown Seeds or Fill etc.
											local prozent = VehicleInspector:getProzentString(fillLevelVehicle.fillLevel, fillLevelVehicle.capacity, true);
											if (prozent <= 100 and invertProzent) then outputString[#outputString].txtColor = { 0/255, 255/255,   0/255, 1 };end; --green
											if (prozent >= 55 and not invertProzent) or (prozent <= 60 and invertProzent) then outputString[#outputString].txtColor = { 255/255, 255/255,  0/255, 1 };end; --yellow
											if (prozent >= 75 and not invertProzent) or (prozent <= 25 and invertProzent) then outputString[#outputString].txtColor = { 255/255, 165/255,   0/255, 1 };end; --orange
											if (prozent >= 95 and not invertProzent) or (prozent <= 5 and invertProzent) then outputString[#outputString].txtColor = { 255/255, 0/255, 0/255, 1 };end; --red
											if (prozent >= 100 and not invertProzent) or (prozent <= 0 and invertProzent) then
												table.insert(outputString, 1, {});
												outputString[1].txt = otherFull;
												if invertProzent then outputString[1].txt = otherSaFull;end;
												outputString[1].txtColor = { 255/255, 0/255, 0/255, 1 }; --red Full or Empty
												outputString[1].txtBold = true;
											end;
										end;
									end;
								end;
								if VehicleInspector.simple.seeProzent and fillLevelVehicle.capacity > 0 then
									local prozent = VehicleInspector:getProzentString(fillLevelVehicle.fillLevel, fillLevelVehicle.capacity, false);
									if not VehicleInspector.simple.seeFillLevel then 
										--outputString[#outputString+1] = {};
										outputString[#outputString].txt = tostring(prozent).. "%";										
										if (attachedSprayerAnd <= 1 and attach == 1) or (attachedSprayerAnd == attach) then --Unknown Seeds or Fill etc.
											if (tonumber(prozent) <= 100 and invertProzent) then outputString[#outputString].txtColor = { 0/255, 255/255,   0/255, 1 };end; --green
											if (tonumber(prozent) >= 55 and not invertProzent) or (tonumber(prozent) <= 60 and invertProzent) then outputString[#outputString].txtColor = { 255/255, 255/255,  0/255, 1 };end; --yellow
											if (tonumber(prozent) >= 75 and not invertProzent) or (tonumber(prozent) <= 25 and invertProzent) then outputString[#outputString].txtColor = { 255/255, 165/255,   0/255, 1 };end; --orange
											if (tonumber(prozent) >= 95 and not invertProzent) or (tonumber(prozent) <= 5 and invertProzent) then outputString[#outputString].txtColor = { 255/255, 0/255, 0/255, 1 };end; --red
											if (tonumber(prozent) >= 100 and not invertProzent) or (tonumber(prozent) <= 0 and invertProzent) and not VehicleInspector.simple.seeFillLevel then
												table.insert(outputString, 1, {});
												outputString[1].txt = otherFull;
												if invertProzent then outputString[1].txt = otherSaFull;end;
												outputString[1].txtColor = { 255/255, 0/255, 0/255, 1 }; --red Full oder Empty
												outputString[1].txtBold = true;
											end;										
										end;
									else
										outputString[#outputString].txt = outputString[#outputString].txt.. " (".. tostring(prozent).. "%)";
									end;
								end;
								if VehicleInspector.simple.seeFillName then
									local newString = outputString[#outputString].txt;
									--local fillTypeName = g_currentMission.fillTypeManager.nameToIndex[fillLevelVehicle.fillType];
									local fillTypeName = FillTypeManager.getFillTypeNameByIndex(g_fillTypeManager, fillLevelVehicle.fillType);
									if not VehicleInspector.simple.realFillName then local fillTypeNameTemp = g_fillTypeManager.nameToFillType[fillTypeName].title;fillTypeName = fillTypeNameTemp;end;
									outputString[#outputString].txt = tostring(fillTypeName).. fillNameToFillLevel.. newString;
								end;
								if invertProzent then								
									local newString = outputString[#outputString].txt
									if (attachedSprayerAnd <= 1 and attach == 1) or (attachedSprayerAnd == attach) then
										outputString[#outputString].txt = otherSa.. newString;
									else
										outputString[#outputString].txt = otherSaOrFill.. newString;
									end;
								end;
							end;
						end;						
					end;
					if attach > 0 and VehicleInspector.simple.seeLastAllAttached then
						outputString[#outputString+1] = {};											
						outputString[#outputString].txt = tonumber(attach); --.. " - ".. tonumber(attachedSprayerAnd); --test foundSeedsOr
					end;
					--renderText(posX, VehicleInspector.simple.defaultPosY-txtHeight, size, tostring(vehicle.viVehicleName));
					--txtHeight = txtHeight+getTextHeight(size, tostring(vehicle.viVehicleName));				
				end;
				local newHeight = true;
				if seeLine then
					for b=1, #outputString do
						if outputString[b] ~= nil and string.len(outputString[b].txt) > 0 then
							if newHeight then txtHeight = txtHeight+getTextHeight(size, tostring(outputString[b].txt).. seperator)+diffPosY;newHeight = false;end;
							setTextColor(unpack(VehicleInspector.simple.color.default));							
							setTextBold(VehicleInspector.simple.allTxtBold);
							if outputString[b].txtColor ~= nil then setTextColor(unpack(outputString[b].txtColor));end;
							if outputString[b].txtBold ~= nil then setTextBold(outputString[b].txtBold);end;
							renderText(posX+txtWidth, posY-txtHeight, size, tostring(outputString[b].txt));						
							txtWidth = txtWidth+diffPosX+getTextWidth(size, tostring(outputString[b].txt));
							--seperator
							setTextColor(unpack(VehicleInspector.simple.color.default));							
							setTextBold(VehicleInspector.simple.allTxtBold);
							renderText(posX+txtWidth, posY-txtHeight, size, seperator);
							txtWidth = txtWidth+diffPosX+getTextWidth(size, seperator);
							--seperator
						end;
					end;
				end;
			end;
		end;
	end;	
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;

function VehicleInspector:getFullSize()
	if g_currentMission.paused or
	g_currentMission.inGameMenu.paused or	
	g_currentMission.inGameMenu.isOpen or 
	g_currentMission.physicsPaused then
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.manualPaused then return false;end;
	return true;end;
	return false;
end;

function VehicleInspector:getIngameMap()
	if g_gameSettings.ingameMapState == 1 then return true;end;
	return false;
end;

function VehicleInspector:isInvertFill(typeName)
	for key,value in pairs(VehicleInspector.simple.searchInvert) do
		--print("typeName...".. tostring(typeName).. " - invertName...".. tostring(VehicleInspector.simple.searchInvert[key]))
		if string.find(VehicleInspector.simple.searchInvert[key], typeName) and string.len(typeName) == string.len(VehicleInspector.simple.searchInvert[key]) then return true;end;		
	end;
	return false;
end;

function VehicleInspector:getProzentString(fill, capacity, aNumber)	
	if not aNumber then
		return string.format("%1.0f", "".. tonumber(fill)/tonumber(capacity)*100);
	else
		return fill/capacity*100;
	end;
end;

function VehicleInspector:getSpeed(vehicle)
	local speed = Utils.getNoNil(vehicle.lastSpeed, 0)*3600; --lastSpeed,speedDisplayDt	
	if g_gameSettings:getValue('useMiles') then speed = Utils.getNoNil(vehicle.lastSpeed, 0)*0.62;end;
	if vehicle.viVehicleName == "Train" or vehicle.trainSystem ~= nil then speed = Utils.getNoNil(vehicle.lastSpeed, 0)*3.6;end;
	return string.format("%1.0f", "".. Utils.getNoNil(speed, 0));
end;

function VehicleInspector:getIsOnField(vehicle)
    local wx,wy,wz = getWorldTranslation(vehicle.components[1].node);
    local densityBits = getDensityAtWorldPos(g_currentMission.terrainDetailId, wx, wy, wz);
    return densityBits, densityBits ~= 0;
end;

function VehicleInspector:getAttachedAndSprayerAnd(vehicle, attachedLimit)	
	local attachTable = vehicle.getAttachedImplements(vehicle)
	local attached = 0;
	local attachedSprayerAnd = 0;
	if attachTable ~= nil and attachedLimit <= VehicleInspector.simple.attachedLimit then		
		for _,attach in pairs(attachTable) do		
			if attach.object ~= nil and attach.object.typeName ~= nil then
				local typeName = Utils.getNoNil(string.lower(attach.object.typeName), "Unknown");
				if not string.find(typeName, "implements") and not string.find(typeName, "Unknown") then
					attached = attached+1;
				end;
				VehicleInspector:isInvertFill(typeName)
				if VehicleInspector:isInvertFill(typeName) then --string.find(typeName, "sowing") or string.find(typeName, "sprayer") or string.find(typeName, "manure") or string.find(typeName, "fertilizer") then
					attachedSprayerAnd = attachedSprayerAnd+1;
				end;
				local tempAttached, tempAttachedSprayerAnd = VehicleInspector:getAttachedAndSprayerAnd(attach.object, attachedLimit+1);
				attached = attached+tempAttached;
				attachedSprayerAnd = attachedSprayerAnd+tempAttachedSprayerAnd;
			end;
		end;
	end;
	return attached, attachedSprayerAnd;
end;

--VI LS17 Script
function VehicleInspector:setVehicleName(self, vehicle, attachable)
	local vehicleName = "Unknown";
	local category = "Unknown";
	function setAlternativeName()
		if vehicle.baleWidth ~= nil then
			vehicle.viVehicleName = "Bale";
			vehicleName = "Bale";
		elseif vehicle.fillablePalletDirtyFlag ~= nil then
			vehicle.viVehicleName = "Pal.";
			vehicleName = "Pal.";
		end;
	end;
	--vehicle.getFullName(vehicle) okay return New Holland Tx 32
	--vehicle.getName(vehicle) okay return Tx32
	--!! not all vehicle.fullViewName = Combine
	--controlGroupNames --a table
	--vehicle.getControllerName(vehicle) okay return your User name
	--className = Vehicle
	--name = combineDrivable
	--nicknameRendering --a table
	--vehicle.typeName = 
	--vehicle.typeDesc = 
	
	--g_currentMission.vehicles.getIsVehicleControlledByPlayer()
	--getIsControlled()
	--getControllerName()
	--getFillUnitFillLevelPercentage()
	--getFillLevelInformation()
	
	if vehicle.configFileName == nil then 
		setAlternativeName();
		vehicle.viVehicleName = vehicleName;
		return;
	end;
	if vehicle.viVehicleName ~= nil then return;end;
	--local storeItem = StoreItemsUtil.storeItemsByXMLFilename[Utils.getNoNil(vehicle.configFileName, vehicle.xmlFilename):lower()];
    --if storeItem ~= nil then
    --    if storeItem.name ~= nil then
    --        vehicleName = tostring(storeItem.name);
    --    end;
        --if storeItem.category ~= nil and storeItem.category ~= "" then
        --    category = tostring(storeItem.category);
        --end;	
	--end;		
	
	vehicleName = tostring(vehicle.getFullName(vehicle));
	
	--local vehicleXml = loadXMLFile("MultiOverlayV2_XML", vehicle.configFileName, "vehicle");
	if vehicle.configFileName ~= nil then
		if string.find(tostring(vehicle.configFileName), "locomotive") then
			vehicleName = "Train";		
			if not attachable then vehicle.typeDesc = vehicleName;end;
		elseif string.find(tostring(vehicle.configFileName), "stationCrane") then
			vehicleName = "Crane";
			if not attachable then vehicle.typeDesc = vehicleName;end;
		elseif string.find(tostring(vehicle.configFileName), "wagon") then
			vehicleName = "WagonFill";
			if string.find(tostring(vehicle.configFileName:lower()), "timber") then
				vehicleName = "WagonTimber";
			end;
			if attachable then vehicle.typeDesc = vehicleName;end;
		elseif string.find(tostring(vehicle.configFileName), "ka26") then
			vehicleName = "Heli";
			if not attachable then vehicle.typeDesc = vehicleName;end;
		elseif vehicle.time ~= nil and vehicle.time > 0 then
			vehicleName = vehicleName.. "-Missions Vehicle";
		end;
	end;
	if vehicleName == "Unknown" then setAlternativeName();end;
	--tableVehicle.name = vehicleName;	
	vehicle.viVehicleName = vehicleName;
end;

function VehicleInspector:stringSplit(txtString, delimiter)
	local result = {};
	local from  = 1;
	local delim_from, delim_to = string.find( txtString, delimiter, from  );
	while delim_from do
		table.insert( result, string.sub( txtString, from , delim_from-1 ) );
		from  = delim_to + 1;
		delim_from, delim_to = string.find( txtString, delimiter, from  );
	end;
	table.insert( result, string.sub( txtString, from  ) );
	return result;
end;